<?php
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
/* FOR USE WITH NEW ADMIN PLUGIN CONFIGURATION SCHEME */

if (!GALLERY_ADMIN_MODE) {
	cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

require_once './plugins/category_theme/initialize.inc.php';

// note whether we are being called from the plugin manager
$category_theme_ipm = function_exists('display_plugin_list');

$theme_names = form_get_foldercontent('themes/', 'folder', '', array('sample', '.svn'));

// add our style sheet
if ($category_theme_ipm) {
	echo '<style type="text/css">';readfile('plugins/category_theme/css/cat_theme.css');echo'</style>';
} else {
	$head_meta = '<link rel="stylesheet" href="plugins/category_theme/css/cat_theme.css" type="text/css" />';
	$head_titl = $lang_plugin_category_theme['cat_theme'].' - '.$lang_gallery_admin_menu['admin_lnk'];
	pageheader($head_titl, $head_meta);
}

if ($superCage->post->keyExists('submit')) {
	if (!$category_theme_ipm) {
		if (!checkFormToken()) {
			global $lang_errors;
			cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
		}
	}
	category_theme_process_form();
}

category_theme_display_form($theme_names);


function category_theme_display_form ($themes)
{
	global $superCage, $CONFIG, $lang_common, $lang_gallery_admin_menu, $category_theme_ipm, $lang_plugin_category_theme;

	if (!$category_theme_ipm) {
		echo '<form action="'.$superCage->server->getEscaped('REQUEST_URI').'" method="post">';
	}
	
	$submit_icon = cpg_fetch_icon('ok', 1);
	$thead = $lang_plugin_category_theme['config'];

	starttable('100%', $thead, 3);

	echo '<tr class="ctbl-head cattblrow"><th>'.$lang_plugin_category_theme['cat_name'].'</th><th>'.$lang_plugin_category_theme['cat_theme'].'</th><th>'.$lang_plugin_category_theme['cat_desc'].'</th></tr>';

	$cats = cpg_db_fetch_rowset(cpg_db_query("SELECT `cid`,`name`,`depth`,`description`,`theme_name` FROM {$CONFIG['TABLE_CATEGORIES']} ORDER BY `lft`"));

	foreach ($cats as $cat) {
		echo '<tr class="cattblrow"><td>'.str_repeat('&nbsp;&nbsp;&nbsp;', $cat['depth']-1).$cat['name'].'</td><td>' . themeSelectHtml($themes, $cat['cid'], $cat['theme_name']) . '</td><td>'.$cat['description'].'</td></tr>';
	}

	endtable();

	echo <<<EOT
		<div class="tableb" colspan="3" style="text-align:center">
			<button value="{$lang_common['apply_changes']}" name="submit" class="button" type="submit">{$submit_icon}{$lang_common['apply_changes']}</button>
		</div>
EOT;

	if (!$category_theme_ipm) {
		list($timestamp, $form_token) = getFormToken();
		echo "<input type=\"hidden\" name=\"form_token\" value=\"{$form_token}\" />";
		echo "<input type=\"hidden\" name=\"timestamp\" value=\"{$timestamp}\" />";
		echo '</form>';
		if (version_compare(COPPERMINE_VERSION, '1.6.0', '<')) {
			pagefooter();
		}
	}
}


function category_theme_process_form ()
{
	global $CONFIG, $superCage, $lang_common, $lang_plugin_category_theme;

	$stngs = $superCage->post->getEscaped('theme');
	foreach($stngs as $cat=>$theme) {
		cpg_db_query("UPDATE {$CONFIG['TABLE_CATEGORIES']} SET `theme_name`='{$theme}' WHERE `cid`={$cat}");
	}
	msg_box('',$lang_plugin_category_theme['saved']);
	echo '<br />';
}


function themeSelectHtml ($themes, $cid, $sel)
{
	global $lang_plugin_category_theme;

	$opts = array('<option value="">' . $lang_plugin_category_theme['sel_default'] . '</option>');
	foreach ($themes as $theme) {
		$opts[] = '<option value="' . $theme . '"' . ($theme==$sel?' selected':'') . '>' . $theme . '</option>';
	}
	return '<select name="theme['.$cid.']" id="theme'.$cid.'" class="listbox" size="1">' . implode('', $opts) . '</select>';
}
